/*
This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.

Copyright (c) 2015 CommandCrafter

This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.
To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a 
letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

/* ******* Security Camera Mod by CommandCrafter ******* */

var cameraPosition=false;
var camera;
var cameraNumber=0;
var dismiss=false;
var a;
var b;
var c;

ModPE.setItem(501, "record_11", 0, "Security Camera", 0);
Item.addShapedRecipe(501, 1, 0, [
	"sri",
	"ggs",
	"sri"], ["s", 1, 0, "r", 331, 0, "g", 102, 0, "i", 265, 0]);

ModPE.setItem(502, "record_13", 0, "Security Camera View", 0);
Item.addShapedRecipe(502, 1, 0, [
	"srs",
	"gig",
	"srs"], ["i", 265, 0, "r", 331, 0, "s", 1, 0, "g", 102, 0]);

ModPE.setItem(503, "record_blocks", 0, "Camera Remover", 0);
Item.addShapedRecipe(503, 1, 0, [
	"sss",
	"rir",
	"sss"], ["s", 1, 0, "r", 331, 0, "i", 265, 0]);

function useItem(x, y, z)
{
	if(Player.getCarriedItem()==501)
	{
		if(cameraNumber==1)
		{
			clientMessage(ChatColor.RED + "You can place only one Security Camera.");
		}else
		{
			Player.addItemInventory(501, -1, 0);
			camera = Level.spawnMob(x+0.5, y+0.8, z+0.5, 11, "mob/Security Camera Texture.png");
			Entity.setHealth(camera, 9999);
			Entity.setRenderType(camera, cameraRenderer.renderType);
			cameraPosition=true;
			a=x+0.5;
			b=y+0.8;
			c=z+0.5;
			cameraNumber=1;
		}
	}
}

function modTick()
{
	if(Player.getCarriedItem()==502)
	{
		dismiss=true;
		var ctx = com.mojang.minecraftpe.MainActivity.currentMainActivity.get();
	ctx.runOnUiThread(new java.lang.Runnable({ run: function() {
		try{
			var layout = new android.widget.RelativeLayout(ctx);
			var button = new android.widget.Button(ctx);
			button.setText("CV");
			//button.setWidth(100);
			//button.setHeight(100);
			button.setOnClickListener(new android.view.View.OnClickListener({
				onClick: function(viewarg) {
				ModPE.setCamera(camera);
				}
			}));
			layout.addView(button);
			
			
			btnWindow = new android.widget.PopupWindow(layout, dip2px(ctx, 48), dip2px(ctx, 48));
		//	btnWindow.setContentView(layout);
		//	btnWindow.setWidth(dip2px(ctx, 48));
		//	btnWindow.setHeight(dip2px(ctx, 48));
			btnWindow.setBackgroundDrawable(new android.graphics.drawable.ColorDrawable(android.graphics.Color.TRANSPARENT));
			var flags;
			var bx = 0;
			var by = 0;
			var btnPosC = ModPE.readData("btnPos");
			if(btnPosC == "0"){
                flags = android.view.Gravity.TOP | android.view.Gravity.LEFT;
                by = dip2px(ctx, 20);
			}else if(btnPosC == "1"){
                flags = android.view.Gravity.TOP | android.view.Gravity.RIGHT;
                bx = dip2px(ctx, 38);
                
                btnWindow.setWidth(dip2px(ctx, 38));
			    btnWindow.setHeight(dip2px(ctx, 38));
			}else if(btnPosC == "2"){
                flags = android.view.Gravity.LEFT | android.view.Gravity.BOTTOM;
			}else if(btnPosC == "3" || btnPosC == ""){
                flags = android.view.Gravity.RIGHT | android.view.Gravity.BOTTOM;
			}
			btnWindow.showAtLocation(ctx.getWindow().getDecorView(), flags, bx, by);
		}catch(err){
			print(sFailButton);
		}
	} }));
	}else
	{
	 	if(dismiss)
	 	{
	 		btnWindow.dismiss();
	 		dismiss=false;
	 	}
	}
	if(cameraPosition)
	{
		Entity.setPosition(camera, a, b, c);
		Entity.setVelY(camera, 0);
	}
}

function entityRemovedHook(entity)
{
	if(entity==camera)
	{
		cameraNumber=0;
	}
}

function attackHook(attacker, victim)
{
	if(Player.getCarriedItem()==503)
	{
		if(victim==camera);
		{
			Entity.remove(camera);
			Player.addItemInventory(501, 1, 0);
		}
	}
}

function addCameraToRenderer(renderer)
{
	var model = renderer.getModel();
	var head = model.getPart("head");
	var body = model.getPart("body");
	var rArm = model.getPart("rightArm");
	var lArm = model.getPart("leftArm");
	var rLeg = model.getPart("rightLeg");
	var lLeg = model.getPart("leftLeg");
	head.clear();
	body.clear();
	body.setTextureOffset(0, 0);
	body.addBox(-8, 8, -8, 16, 16, 16);
	rArm.clear();
	lArm.clear();
	rLeg.clear();
	lLeg.clear();
}

var cameraRenderer = Renderer.createHumanoidRenderer();
addCameraToRenderer(cameraRenderer);

function dip2px(ctx, dips)
{
 return Math.ceil(dips * ctx.getResources().getDisplayMetrics().density);
}